﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Runtime.Serialization;
using HeuristicLab.DataAccess;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
using HeuristicLab.Common;

namespace HeuristicLab.Hive.Contracts.BusinessObjects {

  [StorableClass]
  [DataContract]
  public class AppointmentDto : PersistableObject {
    [Storable]
    [DataMember]
    public DateTime StartDate { get; set; }
    [Storable]
    [DataMember]
    public DateTime EndDate { get; set; }
    [Storable]
    [DataMember]
    public bool AllDayEvent { get; set; }
    [Storable]
    [DataMember]
    public bool Recurring { get; set; }
    [Storable]
    [DataMember]
    public Guid RecurringId { get; set; }
    [Storable]
    [DataMember]
    public Guid ResourceId { get; set; }

    public AppointmentDto() { }
    [StorableConstructor]
    protected AppointmentDto(bool deserializing) : base(deserializing) { }
    protected AppointmentDto(AppointmentDto original, Cloner cloner)
      : base(original, cloner) {
      this.AllDayEvent = original.AllDayEvent;
      this.EndDate = original.EndDate;
      this.Recurring = original.Recurring;
      this.RecurringId = original.RecurringId;
      this.ResourceId = original.ResourceId;
      this.StartDate = original.StartDate;
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new AppointmentDto(this, cloner);
    }
  }
}
